﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=3.31
@EndOfDesignText@


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Private DT(8) As Byte
	Private rtc As SoftRtc
	Public timelib As ESPTimetools
'	Public wifi As ESP8266WiFi
End Sub

Public Sub StartRTC
	Log("Clock Start")
	
	rtc.Initialize("rtc_Alarm",False)
	Log("RTC Initialised")
	SynchroRTC
End Sub
 
private Sub rtc_Alarm(index As Byte)
'	if index =0 then Main.rcs_Available
	If index=1 Then SynchroRTC
	If index=2 Then Log(getTime)
End Sub

private Sub SynchroRTC
	Dim timestamp As ULong
	timelib.initialize("pool.ntp.org",3600) 'UTC(1) = MEZ
	timestamp=timelib.timestamp
	If timestamp <> 0 Then
'		Log ("Timestamp is:", timestamp)
		If (timelib.issummertime_eu(timelib.getyear(timestamp),timelib.getmonth(timestamp),timelib.getday(timestamp),timelib.gethour(timestamp),1))=True Then
			timestamp=timestamp+3600 'UTC(1) = MEZ +3600sec (1hour) = MESZ
			'case summertime
		Else
			'case wintertime
		End If
		DT(0) = 21   '21st century (ie 2000)
		DT(1) = timelib.getyear(timestamp)-2000   'year
		DT(2) = timelib.getmonth(timestamp)    'month
		DT(3) = timelib.getday(timestamp)   'day
		DT(4) = timelib.gethour(timestamp)   'hour (0-23)
		DT(5) = timelib.getminute(timestamp)   'minute
		DT(6) = timelib.getseconds(timestamp)  'seconds
		DT(7) = 0    'not required.
		rtc.SetClock(DT,0,0)   'offset for France DT +00:00
		Log("RTC is set")
	Else
		Log("RTC is NOT set")
	End If
	rtc.SetAlarm(1,rtc.Sec2DT(rtc.DT2Sec(DT)+rtc.SECONDS_1HOUR*12)) ' next synchro after 12hrs
End Sub

Public Sub getTime As Byte()
	rtc.ReadClock(DT)
	Dim currtime() As Byte = NumberFormat(DT(1)+2000,4,0).getbytes
	currtime = JoinBytes( Array(currtime, "-".getbytes))
	currtime = JoinBytes( Array(currtime,NumberFormat(DT(2),2,0).getbytes))
	currtime = JoinBytes( Array(currtime,"-".getbytes))
	currtime = JoinBytes( Array(currtime,NumberFormat(DT(3),2,0).getbytes))
	currtime = JoinBytes( Array(currtime, "T".getbytes))
	currtime = JoinBytes( Array(currtime,NumberFormat(DT(4),2,0).getbytes))
	currtime = JoinBytes( Array(currtime,":".getbytes))
	currtime = JoinBytes( Array(currtime,NumberFormat(DT(5),2,0).getbytes))
	currtime = JoinBytes( Array(currtime,":".getbytes))
	currtime = JoinBytes( Array(currtime,NumberFormat(DT(6),2,0).getbytes))
'	Log("time =",currtime)
'	rtc.SetAlarm(2,rtc.Sec2DT(rtc.DT2Sec(DT)+10)) ' next synchro after 12hrs
	Return currtime
	
End Sub
